package mki.xml2csv.access;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;

import mki.xml2csv.access.DomAccess;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import com.neocore.httpclient.NeoConnection;
import com.neocore.httpclient.NeoMalformedXPathException;

/**
 * NeoCoreANZXNX
 * @author nagashima
 * @version 1.0
 */
public class NeoCoreAccess {
  /**
   * NeoConnection
   */
  protected NeoConnection neo = null;

  /**
   * NeoConnectioñOCɕԂsessionId
   */
  protected String sessionId = null;

  /**
   * RXgN^
   *
   * @param host zXg
   * @param port |[gԍ
   * @param userid OC[UID
   * @param password pX[h
   * @throws Exception
   */
  public NeoCoreAccess(
      String host,
      int port,
      String userid,
      String password)
      throws Exception {
      try {
          //NeoCoreT[oɃOC
          if (neo == null) {
              neo = new NeoConnection(host, port);
              sessionId = neo.login(userid, password);
          }
      } catch (Exception e) {
          System.out.println("NeoCoreւ̐ڑɎs܂B");
          System.out.println("e = " + e);
          throw e;
      }
  }

  /**
   * RXgN^
   *
   * @param neo NeoConnection
   * @param sessionId sessionID
   */
  public NeoCoreAccess(NeoConnection neo, String sessionId) {
      this.neo = neo;
      this.sessionId = sessionId;
  }

  /**
   * w肳ꂽXMLXML\擾Bem[h̐΃pXXg`ŕԂB
   *
   * @param document ΏXML̃hLg[g
   * @return em[h̐΃pXXg`
   */
  public List getXmlNodeList(String document) {
      List lst = null;
      try {
          DomAccess domAccess = new DomAccess();
          lst = new ArrayList();
          addNode(domAccess, lst, "/ND/" + document);
      } catch (Exception e) {
          System.out.println("e = " + e);
      }
      return lst;
  }

  /**
   * w肳ꂽXMLXML\擾Bem[h̐΃pXStringzŕԂB
   *
   * @param document ΏXML̃hLg[g
   * @return em[h̐΃pXStringz
   */
  public String[] getXmlNodeArray(String document) {
      List lst = getXmlNodeList(document);
      Iterator it = lst.iterator();
      String[] ary = new String[lst.size()];
      int i = 0;
      while(it.hasNext()){
        ary[i] = it.next().toString();
        i++;
      }
      return ary;
  }

  /**
   * getXmlNodeListĂяoăm[h̒TsBċAIɌĂяoB
   *
   * @param domAccess DomAccess
   * @param lst List
   * @param query String
   */
  private void addNode(DomAccess domAccess, List lst, String query) {
      String result = null;
      try {
          lst.add(query);
          result = neo.queryTreeXML(sessionId, query);
          Document doc = domAccess.parseString(result,"UTF-8");
          //[ghLgGg擾
          Element element = doc.getDocumentElement();
          result = element.getChildNodes().item(0).getNodeValue().trim();
          StringTokenizer st = new StringTokenizer(result, ",");
          while (st.hasMoreTokens()) {
              String val = st.nextToken();
              // elementł΍ċA
              if (!val.startsWith("@")) {
                  addNode(domAccess, lst, query + "/" + val);
              } else {
                  lst.add(query + "/" + val);
              }
          }
      } catch (Exception e) {
          System.out.println("e = " + e);
      }
  }

  /**
   * NeoCoreɊi[ĂXML̃hLg[gStringzŕԂB
   *
   * @param flag truew肳ꂽꍇcount0̗vf͑ΏۂƂȂ
   * @return String[]
   */
  public String[] getDocumentList(boolean flag) {
      String[] ary = null;
      try {
          //NeoCoreXMLf[^擾
          String result = neo.queryTreeXML(sessionId, "/ND");
          //System.out.println("result = " + result);
          DomAccess dom = new DomAccess();
          Document doc = dom.parseString(result,"UTF-8");
          //[ghLgGg擾
          Element element = doc.getDocumentElement();
          String str = element.getChildNodes().item(0).getNodeValue();
          //System.out.println("---" + str + "---");
          StringTokenizer st = new StringTokenizer(str.trim(), ",");
          List lst = new ArrayList();
          //ary = new String[st.countTokens()];
          //int i = 0;
          while (st.hasMoreTokens()) {
              String s = st.nextToken();
              //System.out.println("s=" + s);
              if (flag) {
                  int cnt = queryCountXML("/ND/" + s);
                  //System.out.println("cnt=" + cnt);
                  if (cnt == 0) {
                      continue;
                  }
              }
              lst.add(s);
              //ary[i] = st.nextToken();
              //i++;
          }
          Iterator it = lst.iterator();
          ary = new String[lst.size()];
          int i = 0;
          while (it.hasNext()) {
              ary[i] = it.next().toString();
              i++;
          }
      } catch (Exception e) {
          System.out.println("e = " + e);
      }
      return ary;
  }

  /**
   * NeoConnectionqueryCountXML\bhŕԋp錋ʂintɕϊĕԂB
   *
   * @param query NG
   * @return int
   */
  public int queryCountXML(String query) {
      int count = 0;
      try {
          DomAccess dom = new DomAccess();

          query = "count(" + query + ")";
          String result = neo.queryXML(sessionId, query);

          //String result = neo.queryCountXML(sessionId, query, true);
          Document doc = dom.parseString(result,"UTF-8");
          Element elmResult = doc.getDocumentElement();
          //System.out.println("result=" + result);
          //NodeList lstNode = elmResult.getElementsByTagName("Count");
          //NodeList lstNode = elmResult.getElementsByTagName("Query-Results");
          //NodeList lstNode = doc.getElementsByTagName("Query-Results");
          //Element elmNode = (Element) lstNode.item(0);
          String recnum = elmResult.getFirstChild().getNodeValue().trim();
          //String recnum =
          //    elmNode.getChildNodes().item(0).getNodeValue().trim();
          //System.out.println("recnum = " + recnum);
          count = Integer.parseInt(recnum);
      } catch (Exception e) {
          System.out.println("e = " + e);
      }
      return count;
  }

  /**
   * w肳ꂽNG̃`FbNs
   *
   * @param query NG
   * @return NGsȏꍇfalseԂ
   */
  public boolean checkQuery(String query) {
      try {
          String result = neo.queryCountXML(sessionId, query, true);
          //System.out.println("result = " + result);
          return true;
      } catch (NeoMalformedXPathException e) {
          return false;
      } catch (Exception e) {
          return true;
      }
  }

  /**
   * NeoConnectionqueryXML\bh
   *
   * @param query NG
   * @return String
   */
  public String queryXML(String query) {
      String result = null;
      try {
          result = neo.queryXML(sessionId, query);
          //System.out.println("result = " + result);
          return result;
      } catch (Exception e) {
          return result;
      }
  }

  /**
   * NeoConnectionqueryTreeXML\bh
   *
   * @param query NG
   * @return String
   */
  public String queryTreeXML(String query) {
      String str = null;
      try {
          str = neo.queryTreeXML(sessionId, query);
      } catch (Exception e) {
          System.out.println("e = " + e);
      }
      return str;
  }

  /**
   * NeoConnectionstoreXML\bh
   *
   * @param storeXml XgAΏXML
   * @return String
   */
  public String storeXML(String storeXml) {
      String str = null;
      //String query = getConfigQuery(id);
      try {
          str = neo.storeXML(sessionId, storeXml, "", "");
      } catch (Exception e) {
          System.out.println("e = " + e);
      }
      return str;
  }

  /**
   * NeoConnectionstoreXMLBinary\bh
   *
   * @param storeXml XgAΏXML
   * @param enc encoding
   * @return String
   */
  public String storeXMLBinary(String storeXml, String enc) {
      String str = null;
      //String query = getConfigQuery(id);
      try {
          byte[] b =
              neo.storeXMLBinary(
                  sessionId,
                  storeXml.getBytes(enc),
                  null,
                  null);
          str = new String(b);
      } catch (Exception e) {
          System.out.println("e = " + e);
      }
      return str;
  }

}
