package mki.xml2csv.model;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

//import mki.xml.model.XQueryConditionModel;
import mki.xqueryconstructor.core.XQueryConditionModel;

/**
 * `񃂃fNX
 * @author nagashima
 * @version 1.0
 */
public class Xml2CsvConfigModel {
  private String id = null; //Xml2CsvId
  private String host = null; //NeoCoreT[o
  private String port = null; //|[g
  private String userid = null; //[UID
  private String password = null; //pX[h
  private String query = null; //NG[
  private String document = null; //
  private String strRecordTag = null; //R[h^O
  private String csvfile = null; //CSVt@C
  /**
   * }`IJX
   */
  public String multioccurrence = null; //
  /**
   * CSVtB[h^Cv
   */
  public boolean typeFlag = false;
  private String memo = null; //
  /**
   * `
   */
  public List lstFields = null;
  /**
   * }`IJXpMAP
   */
  public Map mapMulti = null;
  /**
   * 
   */
  public List lstConditions = null;
  private boolean whereFlag = false;
  private boolean autoCreatedQueryFlag = false;

  /**
   * RXgN^
   */
  public Xml2CsvConfigModel() {
  }

  public void clear() {
    this.id = null;
    this.host = null;
    this.port = null;
    this.userid = null;
    this.password = null;
    this.query = null;
    this.document = null;
    this.strRecordTag = null;
    this.csvfile = null;
    this.typeFlag = true;
    this.lstFields = null;
  }

  /**
   * ێĂ`XMLStringŕԂ
   *
   * @param encoding encoding
   * @return String
   */
  public String getXml(String encoding) {
    String tmp = "";
    StringBuffer sb = new StringBuffer();
    if (encoding == null || encoding.equals("")) {
      sb.append("<?xml version=\"1.0\" ?>\r\n");
    }
    else {
      sb.append(
          "<?xml version=\"1.0\" encoding=\"" + encoding + "\" ?>\r\n");
    }
    sb.append("<xml2csv>\r\n");
    sb.append("\t<config id=\"" + this.id + "\">\r\n");
    sb.append("\t\t<host>" + this.host + "</host>\r\n");
    sb.append("\t\t<port>" + this.port + "</port>\r\n");
    sb.append("\t\t<userid>" + this.userid + "</userid>\r\n");
    sb.append("\t\t<password>" + this.password + "</password>\r\n");
    sb.append("\t\t<query>" + this.query + "</query>\r\n");
    //sb.append("\t\t<autocreatedqueryflag>" + this.autoCreatedQueryFlag +
    //          "</autocreatedqueryflag>\r\n");
    sb.append("\t\t<whereflag>" + this.whereFlag + "</whereflag>\r\n");
    if (lstConditions != null) {
      sb.append("\t\t<conditions>\r\n");
      Iterator itcond = lstConditions.iterator();
      while (itcond.hasNext()) {
        XQueryConditionModel qmodel =
            (XQueryConditionModel) itcond.next();
        sb.append("\t\t\t<condition>\r\n");
        sb.append(
            "\t\t\t\t<and_or>" + qmodel.getAndor() + "</and_or>\r\n");
        sb.append("\t\t\t\t<node>" + qmodel.getNode() + "</node>\r\n");
        sb.append("\t\t\t\t<func>" + qmodel.getFunc() + "</func>\r\n");
        sb.append("\t\t\t\t<eq>" + qmodel.getEq() + "</eq>\r\n");
        sb.append(
            "\t\t\t\t<value>" + qmodel.getValue() + "</value>\r\n");
        sb.append("\t\t\t</condition>\r\n");
      }
      sb.append("\t\t</conditions>\r\n");
    }

    sb.append("\t\t<document>" + this.document + "</document>\r\n");
    sb.append("\t\t<recordtag>" + this.strRecordTag + "</recordtag>\r\n");
    sb.append("\t\t<csvfile>" + this.csvfile + "</csvfile>\r\n");
    if (this.multioccurrence != null)
      tmp = this.multioccurrence;
    sb.append("\t\t<multioccurrence>" + tmp + "</multioccurrence>\r\n");
    if (this.typeFlag) {
      tmp = "true";
    }
    else {
      tmp = "false";
    }
    sb.append("\t\t<csvtypeflag>" + tmp + "</csvtypeflag>\r\n");
    sb.append("\t\t<memo>" + this.memo + "</memo>\r\n");
    Iterator it = this.lstFields.iterator();
    while (it.hasNext()) {
      String[] str = (String[]) it.next();
      sb.append("\t\t<field>\r\n");
      sb.append("\t\t\t<xmltag>" + str[0] + "</xmltag>\r\n");
      sb.append("\t\t\t<index>" + str[1] + "</index>\r\n");
      sb.append("\t\t\t<csvfield>" + str[2] + "</csvfield>\r\n");
      tmp = str[3];
      if (tmp == null)
        tmp = "";
      sb.append("\t\t\t<csvtype>" + tmp + "</csvtype>\r\n");
      sb.append("\t\t</field>\r\n");
    }
    sb.append("\t</config>\r\n");
    sb.append("</xml2csv>\r\n");
    return sb.toString();
  }

  /**
   * `ID Getter
   * @return `ID
   */
  public String getId() {
    return id;
  }

  /**
   * NeoCoreT[ozXg Getter
   * @return NeoCoreT[ozXg
   */
  public String getHost() {
    return host;
  }

  /**
   * NeoCoreT[o|[gԍ Getter
   * @return NeoCoreT[o|[gԍ
   */
  public String getPort() {
    return port;
  }

  /**
   * NeoCoreT[o[UID Getter
   * @return NeoCoreT[o[UID
   */
  public String getUserid() {
    return userid;
  }

  /**
   * NeoCoreT[opX[h Getter
   * @return NeoCoreT[opX[h
   */
  public String getPassword() {
    return password;
  }

  /**
   * hLg[g Getter
   * @return hLg[g
   */
  public String getDocument() {
    return document;
  }

  /**
   * NG Getter
   * @return NG
   */
  public String getQuery() {
    return query;
  }

  /**
   * `ID Setter
   * @param string `ID
   */
  public void setId(String string) {
    id = string;
  }

  /**
   * NeoCoreT[ozXg Setter
   * @param string NeoCoreT[ozXg
   */
  public void setHost(String string) {
    host = string;
  }

  /**
   * NeoCoreT[o|[gԍ Setter
   * @param string NeoCoreT[o|[gԍ
   */
  public void setPort(String string) {
    port = string;
  }

  /**
   * NeoCoreT[o[UID Setter
   * @param string NeoCoreT[o[UID
   */
  public void setUserid(String string) {
    userid = string;
  }

  /**
   * NeoCoreT[opX[h Setter
   * @param string NeoCoreT[opX[h
   */
  public void setPassword(String string) {
    password = string;
  }

  /**
   * hLg[g Setter
   * @param string hLg[g
   */
  public void setDocument(String string) {
    document = string;
  }

  /**
   * NG Setter
   * @param string NG
   */
  public void setQuery(String string) {
    query = string;
  }

  /**
   * CSVt@Co͐Getter
   * @return
   */
  public String getCsvfile() {
    return csvfile;
  }

  /**
   * lGetter
   * @return
   */
  public String getMemo() {
    return memo;
  }

  /**
   * }`IJXGetter
   * @return
   */
  public String getMultioccurrence() {
    return multioccurrence;
  }

  /**
   * m[hGetter
   * @return
   */
  public String getStrRecordTag() {
    return strRecordTag;
  }

  /**
   * CSVt@Co͐Setter
   * @param string
   */
  public void setCsvfile(String string) {
    csvfile = string;
  }

  /**
   * lSetter
   * @param string
   */
  public void setMemo(String string) {
    memo = string;
  }

  /**
   * }`IJXSetter
   * @param string
   */
  public void setMultioccurrence(String string) {
    multioccurrence = string;
  }

  /**
   * m[hSetter
   * @param string
   */
  public void setStrRecordTag(String string) {
    strRecordTag = string;
  }

  /**
   *
   * @return
   */
  public boolean isWhereFlag() {
    return whereFlag;
  }

  /**
   *
   * @param b
   */
  public void setWhereFlag(boolean b) {
    whereFlag = b;
  }

  /**
   *
   * @return
   */
  public boolean isAutoCreatedQueryFlag() {
    return autoCreatedQueryFlag;
  }

  /**
   *
   * @param b
   */
  public void setAutoCreatedQueryFlag(boolean b) {
    autoCreatedQueryFlag = b;
  }
}
