package mki.xqueryconstructor.core;

/**
 * XQuery1̏\fNX
 * @author nagashima
 * @version 1.0
 */
public class XQueryConditionModel {
  private String andor = "";
  private String node = "";
  private String func = "";
  private String eq = "";
  private String value = "";

  /**
   * RXgN^
   *
   * @param andor "and"܂"or"
   * @param node m[h̑΃pX<br>
   *             m[hsIh(.)n܂ĂKv܂B
   * @param func ֐<br>
   *             wł֐"contains","starts-with","ends-with","integer","double",
   *             "upper-case","lower-case"݂̂łBȊO̊֐w肳ꂽꍇnullɒu܂B
   * @param eq   rZq<br>
   *             wł鉉Zq"=","!=","<=","<",">=",">"łB
   * @param value l
   */
  public XQueryConditionModel(String andor, String node, String func, String eq,
                              String value) throws Exception {
    setAndor(andor);
    setNode(node);
    setFunc(func);
    setEq(eq);
    setValue(value);
  }

  /**
   * "and"܂"or"擾܂
   * @return and܂or
   */
  public String getAndor() {
    return andor;
  }

  /**
   * rZq擾
   * @return rZq
   */
  public String getEq() {
    return eq;
  }

  /**
   * ֐擾
   * @return ֐
   */
  public String getFunc() {
    return func;
  }

  /**
   * m[h̑΃pX̎擾
   * @return m[h
   */
  public String getNode() {
    return node;
  }

  /**
   * l擾
   * @return l
   */
  public String getValue() {
    return value;
  }

  /**
   * "and"܂"or"ݒ肷<br>
   * Q߈ȍ~̏ł́handh܂́horhK{Ŏw肷Kv܂
   * @param string and܂or
   */
  public void setAndor(String string) throws Exception {
    if(string == null){
      string = "";
    }
    if(!string.equals("and") &&
       !string.equals("or") &&
       !string.equals("")){
      throw new Exception("and܂or̂ݎw\ł");
    }
    andor = string;
  }

  /**
   * rZqݒ肷<br>
   * wł鉉Zq"=","!=","<=","<",">=",">"ł
   * @param string rZq
   */
  public void setEq(String string) throws Exception {
    if(string == null){
      string = "";
    }
    if(!string.equals("=") &&
       !string.equals("!=") &&
       !string.equals("<=") &&
       !string.equals("<") &&
       !string.equals(">=") &&
       !string.equals(">") &&
       !string.equals("")){
      throw new Exception("rZq=,!=,<=,<,>=,>̂ݎw\ł");
    }
    eq = string;
  }

  /**
   * ֐ݒ肷<br>
   * wł֐"contains","starts-with","ends-with","integer","double",<br>
   * "upper-case","lower-case"݂̂łBȊO̊֐w肳ꂽꍇnullɒu܂B
   * @param string ֐
   */
  public void setFunc(String string) throws Exception {
    if(string == null){
      string = "";
    }
    if(!string.equals("contains") &&
       !string.equals("starts-with") &&
       !string.equals("ends-with") &&
       !string.equals("integer") &&
       !string.equals("double") &&
       !string.equals("upper-case") &&
       !string.equals("lower-case") &&
       !string.equals("")){
      throw new Exception("֐containsAstarts-withAends-withAintegerAdoubleAupper-caseAlower-casêݎw\ł");
    }
    func = string;
  }

  /**
   * m[h̑΃pXݒ肷<br>
   * @param string m[h
   */
  public void setNode(String string) throws Exception {
    if(!string.startsWith(".")){
      throw new Exception("m[h̓sIh(.)n܂ĂKv܂");
    }
    node = string;
  }

  /**
   * lݒ肷
   * @param string l
   */
  public void setValue(String string) throws Exception {
    if(string == null || string.equals("")){
      throw new Exception("l͕K{Őݒ肷Kv܂");
    }
    value = string;
  }

  /**
   * \쐬ĕԂ
   *
   * @param wflag whereɊ܂ތ`̏ꍇtrueAforɊ܂ތ`̏ꍇfalse
   * @return String
   */
  public String getConditionStr(boolean wflag) {
    String where = "";
    String node = this.node;
    if (wflag) {
      node = "$rec" + this.node.substring(1);
    }
    if (this.func.equals("")) {
      where = node + " " + this.eq + " \"" + this.value + "\"";
    }
    else if (
        this.func.equals("contains")
        || this.func.equals("starts-with")
        || this.func.equals("ends-with")) {
      where = this.func + "(" + node + ",\"" + this.value + "\")";
    }
    else if (this.func.equals("integer") || this.func.equals("double")) {
      where = this.func + "(" + node + ") " + this.eq + " " + this.value;
    }
    else if (
        this.func.equals("upper-case") || this.func.equals("lower-case")) {
      where =
          this.func
          + "("
          + node
          + ") "
          + this.eq
          + " \""
          + this.value
          + "\"";
    }
    return where;
  }
}
