package mki.xqueryconstructor.core;

import java.util.*;

/**
 * XQuery̏ێNX
 * @author nagashima
 * @version 1.0
 */
public class XQueryModel {
  private List lstFor = null;
  private List lstCondition = null;
  private List lstReturn = null;
  private boolean whereFlag = false;
  private boolean newlineFlag = true;
  private String returnTag = "result";

  /**
   * ێĂ񂩂XQuery\쐬ĕԂ
   *
   * @return String
   */
  public String getQuery() {
    StringBuffer sb = new StringBuffer();
    sb.append(getForStr(true));
    if (this.whereFlag) {
      sb.append(getConditionStr());
      sb.append(" ");
      if(newlineFlag){
        sb.append("\n");
      }
    }
    sb.append(getReturnStr());
    return sb.toString();
  }

  /**
   * ێĂXQueryForModelIuWFNg̏񂩂
   * XQueryfor\(String)쐬ĕԂ
   *
   * @return String
   * @param flag truȅꍇAێĂΏo͂
   */
  public String getForStr(boolean flag) {
    StringBuffer sb = new StringBuffer();
    Iterator it = this.lstFor.iterator();
    while (it.hasNext()) {
      XQueryForModel model = (XQueryForModel) it.next();
      sb.append(model.getForStr());
      if (!this.whereFlag && flag && model.getVariable().equals("$rec")) {
        sb.append(getConditionStr());
      }
      sb.append(" ");
      if(newlineFlag){
        sb.append("\n");
      }
    }
    return sb.toString();
  }

  /**
   * ێĂXQueryReturnModelIuWFNg̏񂩂
   * XQueryreturn\(String)쐬ĕԂ
   *
   * @return String
   */
  public String getReturnStr() {
    StringBuffer sb = new StringBuffer();
    sb.append("return ");
    if(newlineFlag){
      //sb.append("\n");
    }
    sb.append("<");
    sb.append(returnTag);
    sb.append(">");
    if(newlineFlag){
      //sb.append("\n");
    }
    Iterator it = this.lstReturn.iterator();
    while (it.hasNext()) {
      XQueryReturnModel model = (XQueryReturnModel) it.next();
      sb.append(model.getReturnStr());
      if(newlineFlag){
        //sb.append("\n");
      }
      //sb.append("\n");
    }
    sb.append("</");
    sb.append(returnTag);
    sb.append(">");
    return sb.toString();
  }

  /**
   * ێĂXQueryConditionModelIuWFNg̏񂩂
   * XQuery̏\(String)쐬ĕԂ
   *
   * @return String
   */
  public String getConditionStr() {
    //ݒ肳ĂȂꍇ̓^[
    if (this.lstCondition == null) {
      return "";
    }
    StringBuffer sb = new StringBuffer();
    Iterator it = this.lstCondition.iterator();
    //System.out.println("lstCondition.size() = " + lstCondition.size());
    int cnt = 0;
    String result = "";
    while (it.hasNext()) {
      XQueryConditionModel model = (XQueryConditionModel) it.next();
      String where = model.getConditionStr(this.whereFlag);
      if (cnt == 0) {
        result = where;
      }
      else {
        result = result + " " + model.getAndor() + " " + where;
      }
      cnt++;
    }
    if (!result.equals("")) {
      if (this.whereFlag) {
        result = "where " + result;
      }
      else {
        result = "[" + result + "]";
      }
    }
    return result;
  }

  /**
   * ListGetter
   * @return
   */
  List getLstCondition() {
    return lstCondition;
  }

  /**
   * forListGetter
   * @return
   */
  List getLstFor() {
    return lstFor;
  }

  /**
   * ێĂXQueryForModel̐Ԃ܂
   *
   * @return int
   */
  public int getForModelCount(){
    return lstFor.size();
  }

  /**
   * w肳ꂽindexXQueryForModelIuWFNgԂ܂B
   *
   * @param index index
   * @return XQueryForModel
   */
  public XQueryForModel getForModel(int index){
    return (XQueryForModel)lstFor.get(index);
  }

  /**
   * returnListGetter
   * @return
   */
  List getLstReturn() {
    return lstReturn;
  }

  /**
   * ێĂXQueryReturnModel̐Ԃ܂
   *
   * @return int
   */
  public int getReturnModelCount(){
    return lstReturn.size();
  }

  /**
   * w肳ꂽindexXQueryReturnModelIuWFNgԂ܂B
   *
   * @param index index
   * @return XQueryReturnModel
   */
  public XQueryReturnModel getReturnModel(int index){
    return (XQueryReturnModel)lstReturn.get(index);
  }

  /**
   * ListSetter
   * @param list
   */
  void setLstCondition(List list) {
    lstCondition = list;
  }

  /**
   * w肳ꂽXQueryConditionModelIuWFNgXQueryModeladd܂
   *
   * @param model XQueryConditionModel
   */
  public void addConditionModel(XQueryConditionModel model) {
    if(lstCondition == null){
      lstCondition=new ArrayList();
    }
    lstCondition.add(model);
  }

  /**
   * w肳ꂽXQueryConditionModelIuWFNgXQueryModel̎w肳ꂽʒuadd܂
   *
   * @param index int
   * @param model XQueryConditionModel
   */
  public void addConditionModel(int index,XQueryConditionModel model) {
    if(lstCondition == null){
      lstCondition=new ArrayList();
    }
    lstCondition.add(index,model);
  }

  /**
   * ێĂXQueryConditionModel̐Ԃ܂
   *
   * @return int
   */
  public int getConditionModelCount(){
    if(lstCondition == null){
      return 0;
    }
    return lstCondition.size();
  }

  /**
   * w肳ꂽindexXQueryConditionModelIuWFNgԂ܂B
   *
   * @param index index
   * @return XQueryConditionModel
   */
  public XQueryConditionModel getConditionModel(int index){
    if(lstCondition == null){
      return null;
    }
    return (XQueryConditionModel)lstCondition.get(index);
  }

  /**
   * ێĂXQueryConditionModelIuWFNgNA܂
   */
  public void clearConditionModel(){
    lstCondition = null;
  }

  /**
   * forListSetter
   * @param list
   */
  void setLstFor(List list) {
    lstFor = list;
  }

  /**
   * returnListSetter
   * @param list
   */
  void setLstReturn(List list) {
    lstReturn = list;
  }

  /**
   * wheretO擾<br>
   * ێĂƂ
   * getQuery\bh܂getConditionStr\bhŕԂ
   * whereƂďo͂ꍇtrueԂA
   * forɊ܂߂ꍇfalseԂBftHgfalse
   * @return
   */
  public boolean isWhereFlag() {
    return whereFlag;
  }

  /**
   * sR[htO擾<br>
   * getQuery\bh܂getForStr\bh܂getReturnStr\bh
   * ԂXQuery\ɉsR[h܂߂ꍇtrueA
   * ܂߂ȂꍇfalseBftHgtrue
   * @return
   */
  public boolean isNewLineFlag() {
    return newlineFlag;
  }

  /**
   * return^O擾<br>
   * getQuery\bh܂getReturnStr\bhŕԂ
   * returnŎgp1R[h͂ރ^Õ^O擾B
   * ftHgresult
   * @return
   */
  public String getReturnTag() {
    return returnTag;
  }

  /**
   * wheretOݒ肷<br>
   * ێĂƂ
   * getQuery\bh܂getConditionStr\bhŕԂ
   * whereƂďo͂ꍇtruew肵A
   * forɊ܂߂ꍇfalsew肷BftHgfalse
   * @param b
   */
  public void setWhereFlag(boolean b) {
    whereFlag = b;
  }

  /**
   * sR[htOݒ肷<br>
   * getQuery\bh܂getForStr\bh܂getReturnStr\bh
   * ԂXQuery\ɉsR[h܂߂ꍇtrueA
   * ܂߂ȂꍇfalseBftHgtrue
   * @param returnFlag
   */
  public void setNewLineFlag(boolean newlineFlag) {
    this.newlineFlag = newlineFlag;
  }

  /**
   * return^Oݒ肷<br>
   * getQuery\bh܂getReturnStr\bhŕԂ
   * returnŎgp1R[h͂ރ^Õ^Oݒ肷B
   * ftHgresult
   * @param returnTag
   */
  public void setReturnTag(String returnTag) {
    this.returnTag = returnTag;
  }
}
